<?php
// +---------------------------------------------------------------------------+
// | This phpblock Blog Block for Geeklog                                      |
// +---------------------------------------------------------------------------+
// | 最新記事を表示（PHPブロックや静的ページなどへ表示できる）                 |
// |   phpblock_blogentry.php   Version: 1.0.2                                 |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2008 by the following authors:                              |
// |                                                                           |
// | Authors: Hiroshi Sakuramoto - hiro AT winkey DOT jp                       |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Reference: phpblock_blogblock                                             |
// +---------------------------------------------------------------------------+


//  $numrows: 表示件数 (デフォルト5件)
//  $length:  表示するタイトルの文字数 (デフォルト24文字)
//  $introlength:  表示するイントロ記事の文字数 (デフォルト72文字)
//  $trimstr: テキストを文字数で丸めた場合に末尾に付加する文字列(デフォルト"..")
//  $title_postmsg: タイトルの後に付加する文字列 (デフォルト"")
//  $exclude: 表示制限する話題 (デフォルトなし) 指定例: array('General','Geeklog'); 
//  $exclude_flg: $excludeで指定した話題を表示する/表示しないを切り替える (デフォルト=表示しない)
//  $list_flg: 最新記事を<dl><dt>のリストで表示する/表示しないを切り替える (デフォルト=表示しない)
function phpblock_blogblock($numrows=5, $length=24, $introlength=72, $trimstr="..", $title_postmsg="", $exclude=null, $exclude_flg=false, $list_flg=false)
{
    global $_CONF, $_TABLES;
    $retval = '';
    
    // SQL
    if ($exclude_flg == true) {
        $exc = count($exclude)>0 ? implode('',preg_replace('/^(.*)$/'," AND s.tid='$0'",$exclude)) : '';
    } else {
        $exc = count($exclude)>0 ? implode('',preg_replace('/^(.*)$/'," AND s.tid!='$0'",$exclude)) : '';
    }
    
    $sql = "SELECT STRAIGHT_JOIN s.sid, s.tid, s.title, s.date, s.group_id, s.owner_id, ";
    $sql .= "s.perm_owner, s.perm_group, s.perm_members, s.perm_anon, ";
    $sql .= "t.topic, ";
    $sql .= "s.introtext ";
    $sql .= "from {$_TABLES['stories']} as s, {$_TABLES['topics']} as t ";
    $sql .= "WHERE s.title<>'' AND (s.tid = t.tid) AND (date <= NOW()) AND (s.draft_flag = 0) ". $exc;
    $sql .= " ORDER BY s.date DESC LIMIT " . $numrows;
    
    // Get DB
    $result = DB_query($sql);
    $nrows = DB_numRows($result);
    
    // Display title of stories.
    if( $nrows>0 ) {
        $retval .= ($list_flg == false) ? '<div class="blogblock">' : '<dl>' ;
        for( $i=1; $i<=$nrows; $i++ ) {
            $A = DB_fetchArray($result);
            $T_ACCESS=SEC_hasTopicAccess($A['tid']);
            $ACCESS=SEC_hasAccess($A['owner_id'], $A['group_id'] ,$A['perm_owner'] ,$A['perm_group'] ,$A['perm_members'] ,$A['perm_anon']);
            
            // date
            $date = substr($A['date'],0,10);
            // title trim
            $title =  mb_strimwidth($A['title'], 0, $length, $trimstr);
            if( $list_flg == false ) {
                if( $introlength>0 ) {
                    // introtext tag delete
                    $introbuf = preg_replace("/\<br[ \/]*\>/i"," ",$A['introtext']);
                    $tag_regex_ = "[^\"'<>]*(?:\"[^\"]*\"[^\"'<>]*|'[^']*'[^\"'<>]*)*(?:>|(?=<)|$(?!\n))";
                    $introbuf2 = preg_replace("/\<$tag_regex_/i"," ",$A['introtext']);
        //            $introbuf = _phpblock_blockblog_tag_filter($introbuf);
                    // introtext trim
                    $introtext =  mb_strimwidth($introbuf2, 0, $introlength, $trimstr);
                    
                    $retval .= '<div class="blogblock-content'.$i.'">';
                    $retval .= '<h3>'.$date.'</h3>';
                    $retval .= '<h4>'.$title.'</h4>';
                    $retval .= '<p>'.$introtext.'</p>';
                    
                    if ($ACCESS>0 AND $T_ACCESS>0) {
                        $retval .= '<div class="morelink"><a href="'.COM_buildUrl($_CONF['site_url'].'/article.php?story='.$A['sid']).'"><img src="/images/arrow.gif" alt="">more</a></div>'.LB;
                    } else {
                        $retval .= LB;
                    }
                    $retval .= '</div>';
                } else {
                    $retval .= '<div class="blogblock-content'.$i.'">';
                    $retval .= '<h3>'.$date.'</h3>';
                    $retval .= '<h4><a href="'.COM_buildUrl($_CONF['site_url'].'/article.php?story='.$A['sid']).'">'.$title.'</a>'.$title_postmsg.'</h4>'.LB;
                    $retval .= '</div>';
                }
            } else {
                $date = "'" . substr($A['date'],2,8);
                $retval .= '<dt>'.$date.' &nbsp; ';
                $retval .= '<a href="'.COM_buildUrl($_CONF['site_url'].'/article.php?story='.$A['sid']).'">'.$title.'</a>'.$title_postmsg.LB;
                $retval .= '</dt>';
            }
        }
        $retval .= ($list_flg == false) ? '</div>' : '</dl>' ;
    }
    return $retval;
}

// autotags PHP関数 - blogblock
function phpautotags_blogblock($p1, $p2, $fulltag)
{
    if( empty($p1) ) { return ''; }
    // default
    $row = $p1;
    $len = 24;
    $introlen = 72;
    $trimstr = '..';
    $title_postmsg = "";
    $exclude = null;
    $exclude_flg = false;
    
    $px = explode (' ', trim ($p2));
    foreach ($px as $part) {
        if (substr ($part, 0, 4) == 'row:') {
            $a = explode (':', $part);
            $row = $a[1];
        }
        if (substr ($part, 0, 4) == 'len:') {
            $a = explode (':', $part);
            $len = $a[1];
        }
        if (substr ($part, 0, 9) == 'introlen:') {
            $a = explode (':', $part);
            $introlen = $a[1];
        }
        if (substr ($part, 0, 8) == 'trimstr:') {
            $a = explode (':', $part);
            $trimstr = $a[1];
        }
        if (substr ($part, 0, 13) == 'titlepostmsg:') {
            $a = explode (':', $part);
            $title_postmsg = $a[1];
        }
        if (substr ($part, 0, 12) == 'exclude_flg:') {
            $a = explode (':', $part);
            $exclude_flg = $a[1];
        }
        if (substr ($part, 0, 8) == 'exclude:') {
            $a = explode (':', $part);
            $exclude = explode (',', $a[1]);
        }
        if (substr ($part, 0, 9) == 'list_flg:') {
            $a = explode (':', $part);
            $list_flg = $a[1];
        }
    }
    return phpblock_blogblock($row, $len, $introlen, $trimstr, $title_postmsg, $exclude, $exclude_flg, $list_flg);
}

?>